## dragonegg 2.8~20101006

=== Makefile ===
# Specify the gcc executable you will use the dragonegg plugin with here.
GCC?=gcc-4.5

# Specify the copy of LLVM you will build the plugin against by giving its
# llvm-config here.  To use an installed copy of LLVM, specify the installed
# llvm-config (just 'llvm-config' is enough if llvm-config is in your path).
# It is not necessary to install LLVM to build dragonegg against it.  Instead
# you can do an LLVM build and point LLVM_CONFIG to the copy of llvm-config
# that was created during the build.
LLVM_CONFIG?=llvm-config

# Location of the dragonegg source, useful if you want separate source and
# object directories.
SRC_DIR?=$(PWD)

ifndef VERBOSE
	QUIET:=@
endif

COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)

ifeq ($(shell uname),Darwin)
LOADABLE_MODULE_OPTIONS=-bundle -undefined dynamic_lookup
else
LOADABLE_MODULE_OPTIONS=-shared -Wl,-O1 -Wl,--version-script=$(SRC_DIR)/exports.map
endif

GCC_PLUGIN_DIR:=$(shell $(GCC) -print-file-name=plugin)
GCC_VERSION:=$(shell $(GCC) -dumpversion)
GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
TARGET_TRIPLE:=$(shell $(GCC) -dumpmachine)

# NOTE: replace with an informative string when doing a release.
REVISION:=$(shell svnversion -n $(SRC_DIR))

PLUGIN=dragonegg.so
PLUGIN_OBJECTS=llvm-cache.o llvm-convert.o llvm-backend.o llvm-debug.o \
	       llvm-types.o bits_and_bobs.o llvm-abi-default.o

TARGET_OBJECT=llvm-target.o
TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/llvm-target.cpp

TARGET_UTIL_OBJECTS=target.o
TARGET_UTIL=./target

ALL_OBJECTS=$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL_OBJECTS)

CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) \
	     -MD -MP \
	     -DIN_GCC -DREVISION=\"$(REVISION)\" \
	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
	     -I$(SRC_DIR) -I$(GCC_PLUGIN_DIR)/include

LD_OPTIONS+=$(LDFLAGS) $(shell $(LLVM_CONFIG) --ldflags)

# NOTE: The following flags can only be used after TARGET_UTIL has been built.
TARGET_HEADERS+=-DTARGET_NAME=\"$(shell $(TARGET_UTIL) -t)\" \
		-I$(SRC_DIR)/$(shell $(TARGET_UTIL) -p) \
		-I$(SRC_DIR)/$(shell $(TARGET_UTIL) -o)


default: $(PLUGIN)

$(TARGET_UTIL_OBJECTS): %.o : $(SRC_DIR)/utils/%.cpp
	@echo Compiling utils/$*.cpp
	$(QUIET)$(CXX) -c -DTARGET_TRIPLE=\"$(TARGET_TRIPLE)\" \
	$(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_UTIL): $(TARGET_UTIL_OBJECTS)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $^ $(LD_OPTIONS) \
	$(shell $(LLVM_CONFIG) --libs support)

%.o : $(SRC_DIR)/%.c $(TARGET_UTIL)
	@echo Compiling $*.c
	$(QUIET)$(CC) -c $(CPP_OPTIONS) $(TARGET_HEADERS) $(CFLAGS) $<

%.o : $(SRC_DIR)/%.cpp $(TARGET_UTIL)
	@echo Compiling $*.cpp
	$(QUIET)$(CXX) -c $(CPP_OPTIONS) $(TARGET_HEADERS) $(CXXFLAGS) $<

$(TARGET_OBJECT): $(TARGET_UTIL)
	@echo Compiling $(shell $(TARGET_UTIL) -p)/llvm-target.cpp
	$(QUIET)$(CXX) -o $@ -c $(CPP_OPTIONS) $(TARGET_HEADERS) $(CXXFLAGS) \
	$(TARGET_SOURCE)

$(PLUGIN): $(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $(LOADABLE_MODULE_OPTIONS) $(CXXFLAGS) \
	$(LD_OPTIONS) $(PLUGIN_OBJECTS) $(TARGET_OBJECT) \
	$(shell $(LLVM_CONFIG) --libs analysis core ipo scalaropts target \
	$(shell $(TARGET_UTIL) -p))

clean::
	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL)


-include $(ALL_OBJECTS:.o=.d)

# The following target exists for the benefit of the dragonegg maintainers, and
# is not used in a normal build.
GENGTYPE_INPUT=$(SRC_DIR)/llvm-cache.c
GENGTYPE_OUTPUT=$(SRC_DIR)/gt-llvm-cache.h
gt-llvm-cache.h::
	cd $(HOME)/GCC/objects/gcc && ./build/gengtype \
	  -P $(GENGTYPE_OUTPUT) $(GCC_PLUGIN_DIR) gtyp-input.list \
	    $(GENGTYPE_INPUT)
	sed -i "s/ggc_cache_tab .*\[\]/ggc_cache_tab gt_ggc_rc__gt_llvm_cache_h[]/" $(GENGTYPE_OUTPUT)
	sed -i "s/ggc_root_tab .*\[\]/ggc_root_tab gt_pch_rc__gt_llvm_cache_h[]/" $(GENGTYPE_OUTPUT)

## dragonegg 2.8

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	QUIET:=@
 endif
 
-COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
+COMMON_FLAGS=-Wall -fvisibility=hidden
 CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
 CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)

=== debian/changelog ===
dragonegg (2.8-3) unstable; urgency=low

  * Upload to unstable
  * Update of the tags Vcs-Svn & Vcs-Browser
  * Use c++ instead of c++-4.5 for llvm-c++ (Closes: #625893)
  * Allows usage of llvm-gcc-4.5 even if built with different versions of gcc
    it has been built (and display a warning when it is the case). 
    (Closes: #618768)
  * Standards-Version updated to version 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 06 May 2011 23:28:33 +0200

dragonegg (2.8-1) experimental; urgency=low

  * Sync from Ubuntu
  * New upstream release
    * Incompatible plugin version fixed (Closes: #578381)
  * LLVM Packaging team is now the maintainer
  * Add myself to the uploader
  * Standards-Version updated to version 3.9.1
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 00:24:46 +0100

dragonegg (2.8-0ubuntu1) maverick-proposed; urgency=low

  * Final 2.8 release. LP: #632727.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Oct 2010 18:50:58 +0200

dragonegg (2.8~20101006-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Oct 2010 16:05:42 +0200

dragonegg (2.8~20100921-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 21 Sep 2010 22:39:41 +0200

dragonegg (2.8~20100911-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Sep 2010 10:37:04 +0200

dragonegg (2.8~20100907-0ubuntu1) maverick; urgency=low

  * New upstream version, taken from the trunk.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 17:24:30 +0200

dragonegg (2.7-0ubuntu2) maverick; urgency=low

  * Build-depend on llvm-2.7-dev.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Jun 2010 00:22:09 +0200

dragonegg (2.7-0ubuntu1) maverick; urgency=low

  * Upload to maverick.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 May 2010 13:22:45 +0200

dragonegg (2.7-0ubuntu1~ppa3) lucid; urgency=low

  * New upstream version.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 27 Apr 2010 15:09:49 +0200

dragonegg (0~20091229-2) experimental; urgency=low

  * control (llvm-gcc-4.5): Provide and conflict with llvm-gcc.

 -- Robert Millan <rmh.debian@aybabtu.com>  Mon, 04 Jan 2010 13:15:08 +0100

dragonegg (0~20091229-1) experimental; urgency=low

  * Initial release.  (Closes: #563315)

 -- Robert Millan <rmh.debian@aybabtu.com>  Fri, 01 Jan 2010 22:55:02 +0100

=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Arthur Loiret <aloiret@debian.org>, Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 7),
 gcc-4.5-plugin-dev,
 llvm-2.8-dev (>= 2.8),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev,
Standards-Version: 3.9.2
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.5 | g++-4.5
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.5 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc-4.5
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.5, g++-4.5
Provides: llvm-gcc
Conflicts: llvm-gcc
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.  Note that DragonEgg
 is under heavy development and is not mature - it may crash or
 produce wrong code.

=== debian/rules ===
#!/usr/bin/make -f

deb_version		:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version	:= $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
major 			:= $(shell echo $(upstream_version) | sed -e "s/\([0-9]\+\.[0-9]\+\)[\.-].*/\1/g")

plugindir := $(shell gcc-4.5 -print-file-name=plugin | sed 's/4\.\([5-9]\)\../4.\1/')

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/simple-patchsys.mk

stamps/build: apply-patches
	# link with llvm-snapshot
	LDFLAGS=-L/usr/lib/llvm-2.8/lib $(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-2.8/bin/llvm-config \
		-C $(DEB_SRCDIR)
	mkdir -p stamps
	touch $@

stamps/install:
	mkdir -p debian/dragonegg/$(plugindir)
	install -m755 $(DEB_SRCDIR)/dragonegg.so debian/dragonegg/$(plugindir)/
	mkdir -p stamps
	touch $@

stamps/install-llvm-gcc-4.5:
	mkdir -p debian/llvm-gcc-4.5/usr/bin
	sed 's,@plugindir@,$(plugindir),' debian/gcc-wrap.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-4.5/usr/bin/llvm-$$i ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed 's,@plugindir@,$(plugindir),' debian/c++-wrap.in > debian/c++-wrap

build/dragonegg:: stamps/build
install/dragonegg:: stamps/install

install/llvm-gcc-4.5:: stamps/install-llvm-gcc-4.5

clean::
	$(MAKE) clean VERBOSE=1
	rm -f debian/gcc-wrap
	rm -rf stamps

## dragonegg 2.9

=== Makefile ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	QUIET:=@
 endif
 
-COMMON_FLAGS=-Wall -fvisibility=hidden
+COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
 CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
 CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)
 
@@ -37,14 +37,14 @@
 REVISION:=$(shell svnversion -n $(SRC_DIR))
 
 PLUGIN=dragonegg.so
-PLUGIN_OBJECTS=llvm-cache.o llvm-convert.o llvm-backend.o llvm-debug.o \
-	       llvm-types.o bits_and_bobs.o llvm-abi-default.o
+PLUGIN_OBJECTS=cache.o Backend.o Constants.o Convert.o Debug.o DefaultABI.o \
+	       Trees.o Types.o bits_and_bobs.o
 
-TARGET_OBJECT=llvm-target.o
-TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/llvm-target.cpp
+TARGET_OBJECT=Target.o
+TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp
 
-TARGET_UTIL_OBJECTS=target.o
-TARGET_UTIL=./target
+TARGET_UTIL_OBJECTS=TargetInfo.o
+TARGET_UTIL=./TargetInfo
 
 ALL_OBJECTS=$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL_OBJECTS)
 
@@ -52,9 +52,9 @@
 	     -MD -MP \
 	     -DIN_GCC -DREVISION=\"$(REVISION)\" \
 	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
-	     -I$(SRC_DIR) -I$(GCC_PLUGIN_DIR)/include
+	     -I$(SRC_DIR) -I$(SRC_DIR)/ADT -I$(GCC_PLUGIN_DIR)/include
 
-LD_OPTIONS+=$(LDFLAGS) $(shell $(LLVM_CONFIG) --ldflags)
+LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)
 
 # NOTE: The following flags can only be used after TARGET_UTIL has been built.
 TARGET_HEADERS+=-DTARGET_NAME=\"$(shell $(TARGET_UTIL) -t)\" \
@@ -71,8 +71,8 @@
 
 $(TARGET_UTIL): $(TARGET_UTIL_OBJECTS)
 	@echo Linking $@
-	$(QUIET)$(CXX) -o $@ $^ $(LD_OPTIONS) \
-	$(shell $(LLVM_CONFIG) --libs support)
+	$(QUIET)$(CXX) -o $@ $^ $(shell $(LLVM_CONFIG) --libs support) \
+	$(LD_OPTIONS)
 
 %.o : $(SRC_DIR)/%.c $(TARGET_UTIL)
 	@echo Compiling $*.c
@@ -83,16 +83,16 @@
 	$(QUIET)$(CXX) -c $(CPP_OPTIONS) $(TARGET_HEADERS) $(CXXFLAGS) $<
 
 $(TARGET_OBJECT): $(TARGET_UTIL)
-	@echo Compiling $(shell $(TARGET_UTIL) -p)/llvm-target.cpp
+	@echo Compiling $(shell $(TARGET_UTIL) -p)/Target.cpp
 	$(QUIET)$(CXX) -o $@ -c $(CPP_OPTIONS) $(TARGET_HEADERS) $(CXXFLAGS) \
 	$(TARGET_SOURCE)
 
 $(PLUGIN): $(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL)
 	@echo Linking $@
 	$(QUIET)$(CXX) -o $@ $(LOADABLE_MODULE_OPTIONS) $(CXXFLAGS) \
-	$(LD_OPTIONS) $(PLUGIN_OBJECTS) $(TARGET_OBJECT) \
-	$(shell $(LLVM_CONFIG) --libs analysis core ipo scalaropts target \
-	$(shell $(TARGET_UTIL) -p))
+	$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(shell $(LLVM_CONFIG) --libs \
+	analysis core ipo scalaropts target $(shell $(TARGET_UTIL) -p)) \
+	$(LD_OPTIONS)
 
 clean::
 	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL)
@@ -102,11 +102,11 @@
 
 # The following target exists for the benefit of the dragonegg maintainers, and
 # is not used in a normal build.
-GENGTYPE_INPUT=$(SRC_DIR)/llvm-cache.c
-GENGTYPE_OUTPUT=$(SRC_DIR)/gt-llvm-cache.h
-gt-llvm-cache.h::
+GENGTYPE_INPUT=$(SRC_DIR)/cache.c
+GENGTYPE_OUTPUT=$(SRC_DIR)/gt-cache.h
+gt-cache.h::
 	cd $(HOME)/GCC/objects/gcc && ./build/gengtype \
 	  -P $(GENGTYPE_OUTPUT) $(GCC_PLUGIN_DIR) gtyp-input.list \
 	    $(GENGTYPE_INPUT)
-	sed -i "s/ggc_cache_tab .*\[\]/ggc_cache_tab gt_ggc_rc__gt_llvm_cache_h[]/" $(GENGTYPE_OUTPUT)
-	sed -i "s/ggc_root_tab .*\[\]/ggc_root_tab gt_pch_rc__gt_llvm_cache_h[]/" $(GENGTYPE_OUTPUT)
+	sed -i "s/ggc_cache_tab .*\[\]/ggc_cache_tab gt_ggc_rc__gt_cache_h[]/" $(GENGTYPE_OUTPUT)
+	sed -i "s/ggc_root_tab .*\[\]/ggc_root_tab gt_pch_rc__gt_cache_h[]/" $(GENGTYPE_OUTPUT)

=== debian/changelog ===
dragonegg (2.9-2build1) unstable; urgency=low

   * Rebuild for changed (old) gcc_lib_dir location.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Sep 2011 14:50:02 +0200

dragonegg (2.9-2) unstable; urgency=low

  * Fix (probably) the kfreebsd FTBFS (Closes: #635288)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 25 Jul 2011 11:34:20 +0200

dragonegg (2.9-1) unstable; urgency=low

  * New upstream release. Fix build issues. (Closes: #633946) (LP: #770819)
  * Watch file added

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 24 Jul 2011 12:32:35 +0200

=== debian/control ===
--- 
+++ 
@@ -7,10 +7,11 @@
  cdbs,
  debhelper (>= 7),
  gcc-4.5-plugin-dev,
- llvm-2.8-dev (>= 2.8),
+ llvm-2.9-dev (>= 2.9),
  libffi-dev,
  libmpfr-dev,
  libmpc-dev,
+ subversion
 Standards-Version: 3.9.2
 Homepage: http://dragonegg.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/

## dragonegg 3.0

=== Makefile ===
# Specify the gcc executable you will use the dragonegg plugin with here.
GCC?=gcc

# Specify the copy of LLVM you will build the plugin against by giving its
# llvm-config here.  To use an installed copy of LLVM, specify the installed
# llvm-config (just 'llvm-config' is enough if llvm-config is in your path).
# It is not necessary to install LLVM to build dragonegg against it.  Instead
# you can do an LLVM build and point LLVM_CONFIG to the copy of llvm-config
# that was created during the build.
LLVM_CONFIG?=llvm-config

# Location of this Makefile, useful if you want separate source and object
# directories.
TOP_DIR?=$(PWD)

INCLUDE_DIR=$(TOP_DIR)/include
SRC_DIR=$(TOP_DIR)/src

ifndef VERBOSE
	QUIET:=@
endif

COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags)
CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags)

ifeq ($(shell uname),Darwin)
LOADABLE_MODULE_OPTIONS=-bundle -undefined dynamic_lookup
else
LOADABLE_MODULE_OPTIONS=-shared -Wl,-O1 -Wl,--version-script=$(TOP_DIR)/exports.map
endif

GCC_PLUGIN_DIR:=$(shell $(GCC) -print-file-name=plugin)
GCC_VERSION:=$(shell $(GCC) -dumpversion).0
GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
GCC_MICRO=$(word 3, $(subst ., ,$(GCC_VERSION)))
TARGET_TRIPLE:=$(shell $(GCC) -dumpmachine)

# NOTE: replace with an informative string when doing a release.
REVISION:=$(shell svnversion -n $(TOP_DIR))

PLUGIN=dragonegg.so
PLUGIN_OBJECTS=Backend.o Cache.o Constants.o Convert.o Debug.o DefaultABI.o \
	       Trees.o Types.o bits_and_bobs.o

TARGET_OBJECT=Target.o
TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp

TARGET_UTIL_OBJECTS=TargetInfo.o
TARGET_UTIL=./TargetInfo

ALL_OBJECTS=$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL_OBJECTS)

CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) \
	     -MD -MP \
	     -DIN_GCC -DREVISION=\"$(REVISION)\" \
	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
	     -DGCC_MICRO=$(GCC_MICRO) \
	     -I$(INCLUDE_DIR) -I$(GCC_PLUGIN_DIR)/include

LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)

# NOTE: The following flags can only be used after TARGET_UTIL has been built.
TARGET_HEADERS+=-DTARGET_NAME=\"$(shell $(TARGET_UTIL) -t)\" \
		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -p) \
		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -o)


default: $(PLUGIN)

$(TARGET_UTIL_OBJECTS): %.o : $(TOP_DIR)/utils/%.cpp
	@echo Compiling utils/$*.cpp
	$(QUIET)$(CXX) -c -DTARGET_TRIPLE=\"$(TARGET_TRIPLE)\" \
	$(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_UTIL): $(TARGET_UTIL_OBJECTS)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $^ $(shell $(LLVM_CONFIG) --libs support) \
	$(LD_OPTIONS)

%.o : $(SRC_DIR)/%.cpp $(TARGET_UTIL)
	@echo Compiling $*.cpp
	$(QUIET)$(CXX) -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_OBJECT): $(TARGET_UTIL)
	@echo Compiling $(shell $(TARGET_UTIL) -p)/Target.cpp
	$(QUIET)$(CXX) -o $@ -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) \
	$(TARGET_SOURCE)

$(PLUGIN): $(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $(LOADABLE_MODULE_OPTIONS) $(CXXFLAGS) \
	$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(shell $(LLVM_CONFIG) --libs \
	analysis core ipo scalaropts target $(shell $(TARGET_UTIL) -p)) \
	$(LD_OPTIONS)

clean::
	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL)


-include $(ALL_OBJECTS:.o=.d)

# The following target exists for the benefit of the dragonegg maintainers, and
# is not used in a normal build.  You need to specify the path to the GCC build
# directory in GCC_BUILD_DIR.
GENGTYPE_INPUT=$(SRC_DIR)/Cache.cpp
GENGTYPE_OUTPUT=$(INCLUDE_DIR)/dragonegg/gt-cache-$(GCC_MAJOR).$(GCC_MINOR).h
gt-cache.h::
	$(QUIET)$(GCC_BUILD_DIR)/gcc/build/gengtype \
	-r $(GCC_BUILD_DIR)/gcc/gtype.state \
	-P $(GENGTYPE_OUTPUT) $(GENGTYPE_INPUT)
	$(QUIET)sed -i "s/__.*gt/__gt/" $(GENGTYPE_OUTPUT)
	$(QUIET)sed -i "s/_$(GCC_MAJOR)_$(GCC_MINOR)_/_/" $(GENGTYPE_OUTPUT)

=== debian/changelog ===
dragonegg (3.0-1) unstable; urgency=low

  [ Matthias Klose ]
  * New upstream version.
  * Build for gcc-4.6.
  * Linked against the shared libLLVM. 

  [ Sylvestre Ledru ]
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 05 Dec 2011 13:23:18 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends:
  cdbs,
  debhelper (>= 7),
- gcc-4.5-plugin-dev,
- llvm-2.9-dev (>= 2.9),
+ gcc-4.6-plugin-dev,
+ llvm-3.0-dev (>= 3.0),
  libffi-dev,
  libmpfr-dev,
  libmpc-dev,
@@ -20,19 +20,19 @@
 Package: dragonegg
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: gcc-4.5 | g++-4.5
+Recommends: gcc-4.6 | g++-4.6
 Description: GCC plugin that uses LLVM for optimization and code generation
  DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
  and code generators with those from the LLVM project.
  .
- It is a reimplementation of llvm-gcc that works with gcc-4.5 or later.
+ It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
  .
  DragonEgg is under heavy development and is not mature - it may crash or
  produce wrong code.
 
-Package: llvm-gcc-4.5
+Package: llvm-gcc-4.6
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia
-Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.5, g++-4.5
+Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg, gcc-4.6, g++-4.6
 Provides: llvm-gcc
 Conflicts: llvm-gcc
 Description: C front end for LLVM C/C++ compiler

=== debian/rules ===
#!/usr/bin/make -f
LLVM_VERSION = 3.0

deb_version		:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version	:= $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
major 			:= $(shell echo $(upstream_version) | sed -e "s/\([0-9]\+\.[0-9]\+\)[\.-].*/\1/g")

plugindir := $(shell gcc-4.6 -print-file-name=plugin)

include /usr/share/cdbs/1/rules/debhelper.mk

#	CXXFLAGS="-I$(shell /usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config --includedir)/llvm/Config -I$(plugindir)/include/ -fPIC" \
#	CFLAGS="-I$(shell /usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config --includedir)/llvm/Config -I$(plugindir)/include/ -fPIC" 

stamps/build:
	# link with llvm
	LDFLAGS=-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C $(DEB_SRCDIR)
	mkdir -p stamps
	touch $@

stamps/install:
	mkdir -p debian/dragonegg/$(plugindir)
	install -m755 $(DEB_SRCDIR)/dragonegg.so debian/dragonegg/$(plugindir)/
	mkdir -p stamps
	touch $@

stamps/install-llvm-gcc-4.6:
	mkdir -p debian/llvm-gcc-4.6/usr/bin
	sed 's,@plugindir@,$(plugindir),' debian/gcc-wrap.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-4.6/usr/bin/llvm-$$i ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed 's,@plugindir@,$(plugindir),' debian/c++-wrap.in > debian/c++-wrap

build/dragonegg:: stamps/build
install/dragonegg:: stamps/install

install/llvm-gcc-4.6:: stamps/install-llvm-gcc-4.6

clean::
	$(MAKE) clean VERBOSE=1
	rm -f debian/gcc-wrap
	rm -rf stamps

=== debian/watch ===
version=3
opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
http://llvm.org/releases/download.html (?:.*/)?dragonegg-?_?([\d+\.]+|\d+)\.(tar.*|tgz|zip|gz|bz2|) debian

## dragonegg 3.1

=== Makefile ===
--- 
+++ 
@@ -11,13 +11,23 @@
 
 # Location of this Makefile, useful if you want separate source and object
 # directories.
-TOP_DIR?=$(PWD)
+TOP_DIR?=$(CURDIR)
+
+# Normally the plugin will refuse to load into a different gcc to the one it was
+# built against.  Uncomment this (or pass DISABLE_VERSION_CHECK=1 on the 'make'
+# command line) to disable the check.
+#DISABLE_VERSION_CHECK=1
+
+# Where to find the lit.py script and modules, used for running tests.
+LIT_DIR?=$(shell $(LLVM_CONFIG) --src-root)/utils/lit
+# Where to find LLVM utils, used for running tests.
+LLVM_TOOLS_DIR?=$(shell $(LLVM_CONFIG) --obj-root)/$(shell $(LLVM_CONFIG) --build-mode)/bin/
 
 INCLUDE_DIR=$(TOP_DIR)/include
 SRC_DIR=$(TOP_DIR)/src
 
 ifndef VERBOSE
-	QUIET:=@
+QUIET:=@
 endif
 
 COMMON_FLAGS=-Wall -Wextra -fvisibility=hidden
@@ -35,14 +45,14 @@
 GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
 GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
 GCC_MICRO=$(word 3, $(subst ., ,$(GCC_VERSION)))
+GCC_LANGUAGES=$(shell $(GCC) -v 2>&1 | grep '^Configured with:' | sed 's/^.*--enable-languages=\([^ ]*\).*/\1/')
 TARGET_TRIPLE:=$(shell $(GCC) -dumpmachine)
 
-# NOTE: replace with an informative string when doing a release.
-REVISION:=$(shell svnversion -n $(TOP_DIR))
+LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
 
 PLUGIN=dragonegg.so
-PLUGIN_OBJECTS=Backend.o Cache.o Constants.o Convert.o Debug.o DefaultABI.o \
-	       Trees.o Types.o bits_and_bobs.o
+PLUGIN_OBJECTS=Aliasing.o Backend.o Cache.o Constants.o Convert.o Debug.o \
+	       DefaultABI.o Trees.o Types.o bits_and_bobs.o
 
 TARGET_OBJECT=Target.o
 TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp
@@ -54,10 +64,13 @@
 
 CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags) \
 	     -MD -MP \
-	     -DIN_GCC -DREVISION=\"$(REVISION)\" \
+	     -DIN_GCC -DLLVM_VERSION=\"$(LLVM_VERSION)\" \
 	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
 	     -DGCC_MICRO=$(GCC_MICRO) \
-	     -I$(INCLUDE_DIR) -I$(GCC_PLUGIN_DIR)/include
+	     -I$(INCLUDE_DIR) -isystem$(GCC_PLUGIN_DIR)/include
+ifdef DISABLE_VERSION_CHECK
+CPP_OPTIONS+=-DDISABLE_VERSION_CHECK
+endif
 
 LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)
 
@@ -66,6 +79,15 @@
 		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -p) \
 		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -o)
 
+ifdef VERBOSE
+LIT_ARGS+=-v
+else
+LIT_ARGS+=-s -v
+endif
+
+LIT_SITE_CONFIG=test/dragonegg-lit.site.cfg
+TEST_SRC_DIR=$(TOP_DIR)/test
+export PYTHONPATH:=$(TEST_SRC_DIR):$(LIT_DIR)/lit:$(PYTHONPATH)
 
 default: $(PLUGIN)
 
@@ -95,8 +117,32 @@
 	analysis core ipo scalaropts target $(shell $(TARGET_UTIL) -p)) \
 	$(LD_OPTIONS)
 
+$(LIT_SITE_CONFIG): $(TEST_SRC_DIR)/dragonegg-lit.site.cfg.in
+	@echo "Making DragonEgg '$@' file..."
+	$(QUIET)mkdir -p test
+	$(QUIET)echo s=@DRAGONEGG_PLUGIN@=$(CURDIR)/$(PLUGIN)=g > lit.tmp
+	$(QUIET)echo s=@GCC@=$(GCC)=g >> lit.tmp
+	$(QUIET)echo s=@GCC_LANGUAGES@=$(GCC_LANGUAGES)=g >> lit.tmp
+	$(QUIET)echo s=@LLVM_TOOLS_DIR@=$(LLVM_TOOLS_DIR)=g >> lit.tmp
+	$(QUIET)echo s=@TARGET_TRIPLE@=$(TARGET_TRIPLE)=g >> lit.tmp
+	$(QUIET)echo s=@TEST_OUTPUT_DIR@=$(CURDIR)/test/Output=g >> lit.tmp
+	$(QUIET)sed -f lit.tmp $< > $@
+	$(QUIET)-rm -f lit.tmp
+
+check-compilator:: $(PLUGIN) $(LIT_SITE_CONFIG)
+	@echo "Running test suite 'compilator'"
+	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
+	--config-prefix=dragonegg-lit $(TEST_SRC_DIR)/compilator
+
+check-validator:: $(PLUGIN) $(LIT_SITE_CONFIG)
+	@echo "Running test suite 'validator'"
+	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
+	--config-prefix=dragonegg-lit $(TEST_SRC_DIR)/validator
+
+check:: check-validator check-compilator
+
 clean::
-	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL)
+	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL) $(LIT_SITE_CONFIG)
 
 
 -include $(ALL_OBJECTS:.o=.d)

=== debian/changelog ===
dragonegg (3.1-2ubuntu1) quantal; urgency=low

  * Use GCC 4.7 by default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 12 Sep 2012 17:23:41 +0200

dragonegg (3.1-2) unstable; urgency=low

  [ Vincent Legout ]
  * debian/rules: Build with DISABLE_VERSION_CHECK=1 to be able to use a
    different gcc version that the one dragonegg was built against.
    (Closes: #679914)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Jul 2012 23:29:32 +0200

dragonegg (3.1-1) unstable; urgency=low

  * New upstream release
  * Introduce new dragonegg packages to manage both gcc 4.6 & 4.7:
    - dragonegg-4.6 & llvm-gcc-4.6
    - dragonegg-4.7 & llvm-gcc-4.7
    The package dragonegg will install version 4.6

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 30 May 2012 15:32:20 +0200

dragonegg (3.0-3.2) unstable; urgency=low

  * Build-depend on g++-4.6.

 -- Matthias Klose <doko@debian.org>  Wed, 23 May 2012 00:27:00 +0000

dragonegg (3.0-3.1) unstable; urgency=low

  * Non maintainer upload
  * Explicitly build using GCC 4.6. Closes: #667153.

 -- Matthias Klose <doko@debian.org>  Tue, 22 May 2012 23:42:58 +0000

dragonegg (3.0-3) unstable; urgency=low

  * Standards-Version updated to version 3.9.3
  * Update of the uploader list
  * Support of arm. Thanks to Matthias Klose for the patch
  * Enhance the error message (LP: #923349, #941407) (Closes: #656616)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Mar 2012 22:31:11 +0100

dragonegg (3.0-2) unstable; urgency=low

  * Install of llvm-gcc-4.6 removes llvm-gcc-4.5 (Closes: #656610)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 17 Feb 2012 13:09:28 +0100

=== debian/control ===
Source: dragonegg
Section: devel
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Robert Millan <rmh.debian@aybabtu.com>, Sylvestre Ledru <sylvestre@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 7),
 gcc-4.6-plugin-dev,
 gcc-4.7-plugin-dev,
 g++-4.6,
 g++-4.7,
 llvm-3.1-dev (>= 3.1),
 libffi-dev,
 libmpfr-dev,
 libmpc-dev,
 subversion
Standards-Version: 3.9.3
Homepage: http://dragonegg.llvm.org/
Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/pkg-llvm/dragonegg/trunk/

Package: dragonegg
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: dragonegg-4.6
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.6 | g++-4.6
Replaces: dragonegg (<< 3.1)
Breaks: dragonegg (<< 3.1)
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: dragonegg-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gcc-4.7 | g++-4.7
Description: GCC plugin that uses LLVM for optimization and code generation
 DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
 and code generators with those from the LLVM project.
 .
 It is a reimplementation of llvm-gcc that works with gcc-4.6 or later.
 .
 DragonEgg is under heavy development and is not mature - it may crash or
 produce wrong code.

Package: llvm-gcc-4.6
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.6, gcc-4.6, g++-4.6
Provides: llvm-gcc
Conflicts: llvm-gcc, llvm-gcc-4.5
Replaces: llvm-gcc-4.5
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc. 


Package: llvm-gcc-4.7
Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, dragonegg-4.7, gcc-4.7, g++-4.7
Description: C front end for LLVM C/C++ compiler
 The Low-Level Virtual Machine (LLVM) is a collection of libraries and
 tools that make it easy to build compilers, optimizers, Just-In-Time
 code generators, and many other compiler-related programs.
 .
 This is the DragonEgg-based version of llvm-gcc.

=== debian/rules ===
#!/usr/bin/make -f
LLVM_VERSION = 3.1
GCC_VERSION = 4.6
GCC_VERSION_NEXT = 4.7

deb_version		:= $(shell dpkg-parsechangelog | sed -ne "s/^Version: \(.*\)/\1/p")
upstream_version	:= $(shell echo $(deb_version) | sed -e "s/-[^-]*$$//")
major 			:= $(shell echo $(upstream_version) | sed -e "s/\([0-9]\+\.[0-9]\+\)[\.-].*/\1/g")

plugindir := $(shell gcc-$(GCC_VERSION) -print-file-name=plugin)
plugindir_NEXT := $(shell gcc-$(GCC_VERSION_NEXT) -print-file-name=plugin)

include /usr/share/cdbs/1/rules/debhelper.mk

#	CXXFLAGS="-I$(shell /usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config --includedir)/llvm/Config -I$(plugindir)/include/ -fPIC" \
#	CFLAGS="-I$(shell /usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config --includedir)/llvm/Config -I$(plugindir)/include/ -fPIC" 

stamps/build:
	# link with llvm
	mkdir -p $(DEB_SRCDIR)/$(GCC_VERSION)
	cd $(DEB_SRCDIR)/$(GCC_VERSION); \
	GCC=gcc-$(GCC_VERSION) CC=gcc-$(GCC_VERSION) CXX=g++-$(GCC_VERSION) \
	DISABLE_VERSION_CHECK=1 LDFLAGS=-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C ../; \
	mv ../dragonegg.so .

	make LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config clean

	mkdir -p $(DEB_SRCDIR)/$(GCC_VERSION_NEXT)
	cd $(DEB_SRCDIR)/$(GCC_VERSION_NEXT); \
	GCC=gcc-$(GCC_VERSION_NEXT) CC=gcc-$(GCC_VERSION_NEXT) CXX=g++-$(GCC_VERSION_NEXT) \
	DISABLE_VERSION_CHECK=1 LDFLAGS=-L/usr/lib/llvm-$(LLVM_VERSION)/lib $(MAKE) \
		VERBOSE=1 \
		LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config \
		-C ..; \
	mv ../dragonegg.so .
	mkdir -p stamps
	touch $@


stamps/install:
	mkdir -p debian/dragonegg-$(GCC_VERSION)/$(plugindir)
	install -m755 $(DEB_SRCDIR)/$(GCC_VERSION)/dragonegg.so debian/dragonegg-$(GCC_VERSION)/$(plugindir)/
	mkdir -p debian/dragonegg-$(GCC_VERSION_NEXT)/$(plugindir_NEXT)
	install -m755 $(DEB_SRCDIR)/$(GCC_VERSION_NEXT)/dragonegg.so debian/dragonegg-$(GCC_VERSION_NEXT)/$(plugindir_NEXT)/
	mkdir -p stamps
	touch $@

stamps/install-llvm-gcc-$(GCC_VERSION):
	mkdir -p debian/llvm-gcc-$(GCC_VERSION)/usr/bin
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/gcc-wrap.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-$(GCC_VERSION)/usr/bin/llvm-$$i ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed -e 's,@plugindir@,$(plugindir),' -e 's,@GCC_VERSION@,$(GCC_VERSION),' debian/c++-wrap.in > debian/c++-wrap

stamps/install-llvm-gcc-$(GCC_VERSION_NEXT):
	mkdir -p debian/llvm-gcc-$(GCC_VERSION_NEXT)/usr/bin
	sed -e 's,@plugindir@,$(plugindir_NEXT),' -e 's,@GCC_VERSION@,$(GCC_VERSION_NEXT),'  debian/gcc-wrap-next.in > debian/gcc-wrap
	for i in cpp g++ gcc gccbug gcov ; do \
		install -m755 debian/gcc-wrap debian/llvm-gcc-$(GCC_VERSION_NEXT)/usr/bin/llvm-$$i-$(GCC_VERSION_NEXT) ; \
	done
	# Do the same for c++ as gcc but without the version (not provided by
	# gcc-defaults)
	sed -e 's,@plugindir@,$(plugindir_NEXT),' -e 's,@GCC_VERSION@,$(GCC_VERSION_NEXT),' debian/c++-wrap.in > debian/c++-wrap

build/dragonegg-$(GCC_VERSION):: stamps/build
install/dragonegg-$(GCC_VERSION):: stamps/install

install/llvm-gcc-$(GCC_VERSION):: stamps/install-llvm-gcc-$(GCC_VERSION)

install/llvm-gcc-$(GCC_VERSION_NEXT):: stamps/install-llvm-gcc-$(GCC_VERSION_NEXT)

clean::
	rm -rf $(GCC_VERSION)  $(GCC_VERSION_NEXT)
	$(MAKE) clean VERBOSE=1 LLVM_CONFIG=/usr/lib/llvm-$(LLVM_VERSION)/bin/llvm-config
	rm -f debian/gcc-wrap
	rm -rf stamps

## dragonegg 3.2

=== Makefile ===
# Specify the gcc executable you will use the dragonegg plugin with either here
# or on the command line, for example like this (replace gcc-4.7 with the gcc
# you want to load the plugin into):
#   GCC=gcc-4.7 make ...
# If you don't specify anything, then by default the plugin targets the compiler
# used to build it.
GCC?=$(CXX)

# Specify the copy of LLVM you will build the plugin against by giving its
# llvm-config here or on the command line.  To use an installed copy of LLVM,
# specify the installed llvm-config (just 'llvm-config' is enough if it is in
# your path).  It is not necessary to install LLVM to build dragonegg against
# it.  Instead you can do an LLVM build and point LLVM_CONFIG to the copy of
# llvm-config that was created during the build.
LLVM_CONFIG?=llvm-config

# Location of this Makefile, useful if you want separate source and object
# directories.
TOP_DIR?=$(CURDIR)

# Normally the plugin will refuse to load into a different gcc to the one it was
# built against.  Uncomment this (or pass DISABLE_VERSION_CHECK=1 on the 'make'
# command line) to disable the check.
#DISABLE_VERSION_CHECK=1

# Where to find the lit.py script and modules, used for running tests.
LIT_DIR?=$(shell $(LLVM_CONFIG) --src-root)/utils/lit
# Where to find LLVM utils, used for running tests.
LLVM_TOOLS_DIR?=$(shell $(LLVM_CONFIG) --obj-root)/bin:$(shell $(LLVM_CONFIG) \
	--obj-root)/$(shell $(LLVM_CONFIG) --build-mode)/bin/

INCLUDE_DIR=$(TOP_DIR)/include
SRC_DIR=$(TOP_DIR)/src

ifndef VERBOSE
QUIET:=@
endif

COMMON_FLAGS=-Wall -Wextra
ifdef ENABLE_LLVM_PLUGINS
COMMON_FLAGS+=-DENABLE_LLVM_PLUGINS
else
COMMON_FLAGS+=-fvisibility=hidden
endif
CFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cflags | sed -e 's/-Wcovered-switch-default//')
CXXFLAGS+=$(COMMON_FLAGS) $(shell $(LLVM_CONFIG) --cxxflags | sed -e 's/-Wcovered-switch-default//')

ifeq ($(shell uname),Darwin)
LOADABLE_MODULE_OPTIONS=-bundle -undefined dynamic_lookup
else
LOADABLE_MODULE_OPTIONS=-shared -Wl,-O1
ifndef ENABLE_LLVM_PLUGINS
LOADABLE_MODULE_OPTIONS+=-Wl,--version-script=$(TOP_DIR)/exports.map
endif
endif

GCC_PLUGIN_DIR=$(shell $(GCC) -print-file-name=plugin)
GCC_VERSION=$(shell $(GCC) -dumpversion).0
GCC_MAJOR=$(word 1, $(subst ., ,$(GCC_VERSION)))
GCC_MINOR=$(word 2, $(subst ., ,$(GCC_VERSION)))
GCC_MICRO=$(word 3, $(subst ., ,$(GCC_VERSION)))
GCC_LANGUAGES=$(shell $(GCC) -v 2>&1 | grep '^Configured with:' | sed 's/^.*--enable-languages=\([^ ]*\).*/\1/')
TARGET_TRIPLE=$(shell $(GCC) -dumpmachine)

LLVM_VERSION=$(shell $(LLVM_CONFIG) --version)

PLUGIN=dragonegg.so
PLUGIN_OBJECTS=Aliasing.o Backend.o Cache.o ConstantConversion.o Convert.o \
	       Debug.o DefaultABI.o Trees.o TypeConversion.o bits_and_bobs.o

TARGET_OBJECT=Target.o
TARGET_SOURCE=$(SRC_DIR)/$(shell $(TARGET_UTIL) -p)/Target.cpp

TARGET_UTIL_OBJECTS=TargetInfo.o
TARGET_UTIL=./TargetInfo

ALL_OBJECTS=$(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL_OBJECTS)

CPP_OPTIONS+=$(CPPFLAGS) $(shell $(LLVM_CONFIG) --cppflags | sed -e 's/-Wcovered-switch-default//') \
	     -fno-rtti \
	     -MD -MP \
	     -DIN_GCC -DLLVM_VERSION=\"$(LLVM_VERSION)\" \
	     -DGCC_MAJOR=$(GCC_MAJOR) -DGCC_MINOR=$(GCC_MINOR) \
	     -DGCC_MICRO=$(GCC_MICRO) \
	     -I$(INCLUDE_DIR) -isystem$(GCC_PLUGIN_DIR)/include
ifdef DISABLE_VERSION_CHECK
CPP_OPTIONS+=-DDISABLE_VERSION_CHECK
endif

LD_OPTIONS+=$(shell $(LLVM_CONFIG) --ldflags) $(LDFLAGS)

LLVM_COMPONENTS=ipo scalaropts target
ifdef ENABLE_LLVM_PLUGINS
# The same components as the "opt" tool.
LLVM_COMPONENTS+=bitreader bitwriter asmparser instrumentation vectorize
endif

# NOTE: The following flags can only be used after TARGET_UTIL has been built.
TARGET_HEADERS+=-DTARGET_NAME=\"$(shell $(TARGET_UTIL) -t)\" \
		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -p) \
		-I$(INCLUDE_DIR)/$(shell $(TARGET_UTIL) -o)

ifdef VERBOSE
LIT_ARGS+=-v
else
LIT_ARGS+=-s -v
endif

LIT_SITE_CONFIG=test/dragonegg-lit.site.cfg
TEST_SRC_DIR=$(TOP_DIR)/test
export PYTHONPATH:=$(TEST_SRC_DIR):$(LIT_DIR)/lit:$(PYTHONPATH)

default: gcc-sane llvm-config-sane $(PLUGIN)

.PHONY: gcc-sane
gcc-sane:
	$(QUIET)$(GCC) --version > /dev/null

.PHONY: llvm-config-sane
llvm-config-sane:
	$(QUIET)$(LLVM_CONFIG) --version > /dev/null

$(TARGET_UTIL_OBJECTS): %.o : $(TOP_DIR)/utils/%.cpp
	@echo Compiling utils/$*.cpp
	$(QUIET)$(CXX) -c -DTARGET_TRIPLE=\"$(TARGET_TRIPLE)\" \
	$(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_UTIL): $(TARGET_UTIL_OBJECTS)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $^ $(shell $(LLVM_CONFIG) --libs support) \
	$(LD_OPTIONS)

%.o : $(SRC_DIR)/%.cpp $(TARGET_UTIL)
	@echo Compiling $*.cpp
	$(QUIET)$(CXX) -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) $<

$(TARGET_OBJECT): $(TARGET_UTIL)
	@echo Compiling $(shell $(TARGET_UTIL) -p)/Target.cpp
	$(QUIET)$(CXX) -o $@ -c $(TARGET_HEADERS) $(CPP_OPTIONS) $(CXXFLAGS) \
	$(TARGET_SOURCE)

$(PLUGIN): $(PLUGIN_OBJECTS) $(TARGET_OBJECT) $(TARGET_UTIL)
	@echo Linking $@
	$(QUIET)$(CXX) -o $@ $(LOADABLE_MODULE_OPTIONS) $(CXXFLAGS) \
	$(PLUGIN_OBJECTS) $(TARGET_OBJECT) \
	$(shell $(LLVM_CONFIG) --libs $(LLVM_COMPONENTS) \
	$(shell $(TARGET_UTIL) -p)) \
	$(LD_OPTIONS)

$(LIT_SITE_CONFIG): $(TEST_SRC_DIR)/dragonegg-lit.site.cfg.in
	@echo "Making DragonEgg '$@' file..."
	$(QUIET)mkdir -p test
	$(QUIET)echo s=@DRAGONEGG_PLUGIN@=$(CURDIR)/$(PLUGIN)=g > lit.tmp
	$(QUIET)echo s=@GCC@=$(GCC)=g >> lit.tmp
	$(QUIET)echo s=@GCC_LANGUAGES@=$(GCC_LANGUAGES)=g >> lit.tmp
	$(QUIET)echo s=@LLVM_TOOLS_DIR@=$(LLVM_TOOLS_DIR)=g >> lit.tmp
	$(QUIET)echo s=@TARGET_TRIPLE@=$(TARGET_TRIPLE)-gcc-$(GCC_MAJOR).$(GCC_MINOR)=g >> lit.tmp
	$(QUIET)echo s=@TEST_OUTPUT_DIR@=$(CURDIR)/test/Output=g >> lit.tmp
	$(QUIET)sed -f lit.tmp $< > $@
	$(QUIET)-rm -f lit.tmp

.PHONY: check-compilator
check-compilator: $(PLUGIN) $(LIT_SITE_CONFIG)
	@echo "Running test suite 'compilator'"
	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
	--config-prefix=compilator-lit $(TEST_SRC_DIR)/compilator

.PHONY: check-validator
check-validator: $(PLUGIN) $(LIT_SITE_CONFIG)
	@echo "Running test suite 'validator'"
	$(QUIET)$(LIT_DIR)/lit.py $(LIT_ARGS) --param site="$(LIT_SITE_CONFIG)" \
	--config-prefix=validator-lit $(TEST_SRC_DIR)/validator

.PHONY: check
check: check-validator check-compilator

.PHONY: clean
clean:
	$(QUIET)rm -f *.o *.d $(PLUGIN) $(TARGET_UTIL) $(LIT_SITE_CONFIG)


-include $(ALL_OBJECTS:.o=.d)

# The following target exists for the benefit of the dragonegg maintainers, and
# is not used in a normal build.  You need to specify the path to the GCC build
# directory in GCC_BUILD_DIR.
GENGTYPE_INPUT=$(SRC_DIR)/Cache.cpp
GENGTYPE_OUTPUT=$(INCLUDE_DIR)/dragonegg/gt-cache-$(GCC_MAJOR).$(GCC_MINOR).h
.PHONY: gt-cache.h
gt-cache.h:
	$(QUIET)$(GCC_BUILD_DIR)/gcc/build/gengtype \
	-r $(GCC_BUILD_DIR)/gcc/gtype.state \
	-P $(GENGTYPE_OUTPUT) $(GENGTYPE_INPUT)
	$(QUIET)sed -i "s/__.*gt/__gt/" $(GENGTYPE_OUTPUT)
	$(QUIET)sed -i "s/_$(GCC_MAJOR)_$(GCC_MINOR)_/_/" $(GENGTYPE_OUTPUT)

=== debian/changelog ===
dragonegg (3.2-1~exp1ubuntu2) raring; urgency=low

  * No change rebuild for GCC 4.7.3 and 4.6.4.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 16 Apr 2013 00:03:49 +0200

dragonegg (3.2-1~exp1ubuntu1) raring; urgency=low

  * Remove build dependency bloat on subversion.
  * Link with the shared llvm library.
  * Default dragonegg to dragonegg-4.7.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 08 Feb 2013 04:29:16 +0100

dragonegg (3.2-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 21 Dec 2012 08:48:56 +0100

dragonegg (3.2~rc3-1~exp1) experimental; urgency=low

  * New testing release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 06 Dec 2012 15:22:19 +0100

dragonegg (3.2~rc2-1~exp1) experimental; urgency=low

  * New testing release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 04 Dec 2012 20:43:40 +0100

Bdragonegg (3.1-2) unstable; urgency=low

  [ Vincent Legout ]
  * debian/rules: Build with DISABLE_VERSION_CHECK=1 to be able to use a
    different gcc version that the one dragonegg was built against.
    (Closes: #679914)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Jul 2012 23:29:32 +0200

=== debian/control ===
--- 
+++ 
@@ -7,14 +7,13 @@
  cdbs,
  debhelper (>= 7),
  gcc-4.6-plugin-dev,
- gcc-4.7-plugin-dev,
+ gcc-4.7-plugin-dev (>= 4.7.2-10),
  g++-4.6,
- g++-4.7,
- llvm-3.1-dev (>= 3.1),
+ g++-4.7 (>= 4.7.2-10),
+ llvm-3.2-dev (>= 3.2),
  libffi-dev,
  libmpfr-dev,
- libmpc-dev,
- subversion
+ libmpc-dev
 Standards-Version: 3.9.3
 Homepage: http://dragonegg.llvm.org/
 Vcs-Svn: svn://svn.debian.org/svn/pkg-llvm/dragonegg/trunk/
@@ -36,8 +35,8 @@
 Architecture: i386 kfreebsd-i386 hurd-i386 kopensolaris-i386 amd64 kfreebsd-amd64 lpia armel armhf
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: gcc-4.6 | g++-4.6
-Replaces: dragonegg (<< 3.1)
-Breaks: dragonegg (<< 3.1)
+Replaces: dragonegg (<< 3.2)
+Breaks: dragonegg (<< 3.2)
 Description: GCC plugin that uses LLVM for optimization and code generation
  DragonEgg is a GCC plugin (dragonegg.so) that replaces GCC's optimizers
  and code generators with those from the LLVM project.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #!/usr/bin/make -f
-LLVM_VERSION = 3.1
+LLVM_VERSION = 3.2
 GCC_VERSION = 4.6
 GCC_VERSION_NEXT = 4.7
